import cv2
import random
import numpy as np 
import glob 
import os

def ploy(img_mat, ploy_bbox):
    # ploy_bbox = ss.split(" ")

    color_white = (255, 255, 255)
    # color = (0, 255, 0) # 
    color = (random.randint(0, 256), random.randint(0, 256), random.randint(0, 256))

    # img_mat = np.zeros([1024, 1024, 3], np.uint8)
    # img_mat = cv2.imread("tmp_poly.png")
    
    ploy_bbox = list(map(float, ploy_bbox))
    bbox = list(map(int, ploy_bbox))
    print(bbox)
    for i in range(3):
        cv2.line(img_mat, (bbox[i * 2], bbox[i * 2 + 1]), (bbox[(i+1) * 2], bbox[(i+1) * 2 + 1]), color=color, thickness=2)
        cv2.putText(img_mat, str(i), (bbox[i * 2], bbox[i * 2 + 1]), cv2.FONT_HERSHEY_SIMPLEX, 0.75, (0, 0, 255), 2)
    cv2.line(img_mat, (bbox[6], bbox[7]), (bbox[0], bbox[1]), color=color, thickness=2)
    cv2.putText(img_mat, str(i+1), (bbox[6], bbox[7]), cv2.FONT_HERSHEY_SIMPLEX, 0.75, (0, 0, 255), 2)
    return img_mat

def ploy_area(bbox):
    x0, y0, x1, y1, x2, y2, x3, y3 = bbox
    area = (x0*y1 - y0*x1) + (x1*y2 - y1*x2)+ (x2*y3 - y2*x3) + (x3*y0 - y3*x0)
    area = area / 2.0
    return area


if __name__ == "__main__":

    Bbox_A = [0.807617, 0.589844, 0.765137, 0.668457, 0.596680, 0.575684, 0.639160, 0.497559]            
    Bbox_B = [0.804688, 0.590332, 0.765137, 0.667969, 0.593750, 0.580566, 0.633301, 0.503418]

    Bbox_A = list(float(x)*1000 for x in Bbox_A)
    Bbox_B = list(float(x)*1000 for x in Bbox_B)

    img_mat = np.zeros([1024, 1024, 3], np.uint8)
    ploy(img_mat, Bbox_A)
    ploy(img_mat, Bbox_B)
    cv2.imwrite("./tmp_poly.png", img_mat)

    # ss = "611.500000 364.250000 611.500000 441.500000 401.000000 350.250000 442.750000 273.000000"
    # area = ploy_area(list([float(x) for x in ss.split(" ")]))
    # print(area)

    